---
page_type: sample
languages:
- csharp
products:
- windows
- windows-uwp
urlFragment: InkAnalysis
extendedZipContent:
- path: SharedContent
  target: SharedContent
- path: LICENSE
  target: LICENSE
description: "Shows how to recognize handwriting, shapes, and document structure with Ink Analysis."
---

<!---
  category: CustomUserInteractions Inking
  samplefwlink: http://go.microsoft.com/fwlink/p/?LinkId=844937
--->

# Ink Analysis sample

Shows how to recognize handwriting, shapes, and document structure with Ink Analysis.

> **Note:** This sample is part of a large collection of UWP feature samples. 
> You can download this sample as a standalone ZIP file
> [from docs.microsoft.com](https://docs.microsoft.com/samples/microsoft/windows-universal-samples/inkanalysis/),
> or you can download the entire collection as a single
> [ZIP file](https://github.com/Microsoft/Windows-universal-samples/archive/master.zip), but be 
> sure to unzip everything to access shared dependencies. For more info on working with the ZIP file, 
> the samples collection, and GitHub, see [Get the UWP samples from GitHub](https://aka.ms/ovu2uq). 
> For more samples, see the [Samples portal](https://aka.ms/winsamples) on the Windows Dev Center. 

Specifically, this sample covers using the Windows.UI.Input.Inking.Analysis APIs to do the following:
-   Recognize shapes from ink strokes
-   Recognize document structures from ink strokes
-   Recognize handwritten text from ink strokes

## Related topics

**Samples**

[SimpleInk](/Samples/SimpleInk)  
[ComplexInk](/Samples/ComplexInk)  
[OCR](/Samples/OCR)  
[Family Notes sample](https://github.com/Microsoft/Windows-appsample-familynotes)  
[Coloring Book app sample](https://github.com/Microsoft/Windows-appsample-coloringbook)  

**Reference**

[Windows.UI.Input.Inking](http://msdn.microsoft.com/library/windows/apps/br208524)  

## Operating system requirements

**Client:** Windows 10 build 15052

**Server:** Windows Server 2016 Technical Preview

**Phone:** Windows 10 build 15052

## Build the sample

1. If you download the samples ZIP, be sure to unzip the entire archive, not just the folder with the sample you want to build. 
2. Start Microsoft Visual Studio and select **File** \> **Open** \> **Project/Solution**.
3. Starting in the folder where you unzipped the samples, go to the Samples subfolder, then the subfolder for this specific sample, then the subfolder for your preferred language (C++, C#, or JavaScript). Double-click the Visual Studio Solution (.sln) file.
4. Press Ctrl+Shift+B, or select **Build** \> **Build Solution**.

## Run the sample

The next steps depend on whether you just want to deploy the sample or you want to both deploy and run it.

### Deploying the sample

- Select Build > Deploy Solution. 

### Deploying and running the sample

- To debug the sample and then run it, press F5 or select Debug >  Start Debugging. To run the sample without debugging, press Ctrl+F5 or selectDebug > Start Without Debugging. 

