//*********************************************************
//
// Copyright (c) Microsoft. All rights reserved.
// This code is licensed under the MIT License (MIT).
// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

#pragma once 
#include "pch.h"

namespace SDKTemplate
{
    value struct Scenario;

    partial ref class MainPage
    {
    internal:
        static property Platform::String^ FEATURE_NAME
        {
            Platform::String^ get()
            {
                return "MapControl C++ Sample";
            }
        }

        static property Platform::Array<Scenario>^ scenarios
        {
            Platform::Array<Scenario>^ get()
            {
                return scenariosInner;
            }
        }

        static Windows::Devices::Geolocation::Geopoint^ SeattleGeopoint;
        static Platform::Collections::Vector<Windows::UI::Xaml::Controls::Maps::MapElement^>^ CreateCityBuildingsCollection();
        static Platform::Collections::Vector<Windows::UI::Xaml::Controls::Maps::MapElement^>^ CreateCityParksCollection();

    private:
        static Platform::Array<Scenario>^ scenariosInner;
    };

    public value struct Scenario
    {
        Platform::String^ Title;
        Platform::String^ ClassName;
    };

    struct GeoEquals
    {
        bool operator()(const Windows::Devices::Geolocation::BasicGeoposition& left, const Windows::Devices::Geolocation::BasicGeoposition& right) const
        {
            return left.Altitude == right.Altitude && left.Latitude == right.Latitude && left.Longitude == right.Longitude;
        }
    };


}
