---
topic: sample
languages:
- js
products:
- windows
- windows-uwp
---

<!---
  category: Data
  samplefwlink: http://go.microsoft.com/fwlink/p/?LinkId=620573
--->

# Blobs sample

Shows how to use a [Blob](http://msdn.microsoft.com/library/windows/apps/hh453178) and the 
[Window.Storage.Pickers.FileOpenPicker](http://msdn.microsoft.com/library/windows/apps/br207847) to load and display images and video. 
It also shows how to create single- and multi-use **Blob** objects, how to save a [canvas](http://msdn.microsoft.com/library/windows/apps/hh465734) 
to a **Blob** and then load it as an image, how to download content through XHR and save it locally, how to use 
[MSBlobBuilder](http://msdn.microsoft.com/library/windows/apps/hh779016) to create a **Blob**, post a **Blob** to the web, and how to retrieve a 
thumbnail and use a **Blob** to display it in an image tag.

> **Note:** This sample is part of a large collection of UWP feature samples. 
> If you are unfamiliar with Git and GitHub, you can download the entire collection as a 
> [ZIP file](https://github.com/Microsoft/Windows-universal-samples/archive/master.zip), but be 
> sure to unzip everything to access shared dependencies. For more info on working with the ZIP file, 
> the samples collection, and GitHub, see [Get the UWP samples from GitHub](https://aka.ms/ovu2uq). 
> For more samples, see the [Samples portal](https://aka.ms/winsamples) on the Windows Dev Center. 

This sample is written in HTML, CSS, and JavaScript.

Related topics
--------------

[How to select and display an image](http://msdn.microsoft.com/library/windows/apps/hh465499)  

Related technologies
--------------------

[Windows 10 apps using JavaScript](http://msdn.microsoft.com/library/windows/apps/br211385)  
[Blob](http://msdn.microsoft.com/library/windows/apps/hh453178)  
[Window.Storage.Pickers.FileOpenPicker](http://msdn.microsoft.com/library/windows/apps/br207847)  

Operating system requirements
-----------------------------

Client

Windows 10

Build the sample
----------------

1. If you download the samples ZIP, be sure to unzip the entire archive, not just the folder with the sample you want to build. 
2. Start Microsoft Visual Studio 2017 and select **File** \> **Open** \> **Project/Solution**.
3. Starting in the folder where you unzipped the samples, go to the Samples subfolder, then the subfolder for this specific sample, then the subfolder for your preferred language (C++, C#, or JavaScript). Double-click the Visual Studio Solution (.sln) file.
4. Press Ctrl+Shift+B, or select **Build** \> **Build Solution**.

Run the sample
--------------

To debug the app and then run it, press F5 or use **Debug** \> **Start Debugging**. To run the app without debugging, press Ctrl+F5 or use **Debug** \> **Start Without Debugging**.

